package Utopp.Klassen;

import java.util.Vector;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import Utopp.Komponenten.*;

public class ShowKL extends JDialog implements ActionListener
        {
        UmlKlasse kl_;
        int offsetX_ = 150;
        int offsetY_ = 50;
        int breite_ = 0;
        int hoehe_ = 0;
        int zeilenAbstand_ = 2;
        int randUnten_ = 10;
        int randOben_ = 2;
        int randLinks_ = 2;
        JButton okButton_ = new JButton("OK");
        JCheckBox showMBox_ = new JCheckBox("Methoden");
        JCheckBox showABox_ = new JCheckBox("Attribute");

        // Detail-Einstellungen
        boolean showMethoden_ = true;
        boolean showAttribute_ = false;

        public ShowKL(JFrame frame, boolean modal, UmlKlasse KL)
                {
                super(frame,"Darstellung der Klasse",modal);

                kl_ = KL;
                Container cp = getContentPane();

                JPanel MainPanel = new JPanel();
                MainPanel.setLayout(null);

                okButton_.setBounds(20,offsetY_,60,30);
                okButton_.addActionListener(this);

                showABox_.setBounds(20,offsetY_ + 80, 80, 20);
                showABox_.addActionListener(this);

                showMBox_.setBounds(20,offsetY_ + 100, 80, 20);
                showMBox_.addActionListener(this);

                MainPanel.add(okButton_);
                MainPanel.add(showMBox_);
                MainPanel.add(showABox_);
                cp.add(MainPanel);

                //Damit man das Fenster schliessen kann
                this.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);

                }


        private void killYourself()
                {
                this.setVisible(false);
                this.hide();
                }
        public void actionPerformed(ActionEvent event)
                {
                paint(this.getGraphics());
                String command = event.getActionCommand();
                if (command.equals("OK"))
                        {
                        //Beende Dialog
                        killYourself();
                        }


                }


        public void paint(Graphics g)
            {
            super.paint(g);

            showAttribute_ = showABox_.isSelected();
            showMethoden_ = showMBox_.isSelected();
            // Fonts erzeugen
            Font defaultFont = new Font("Default",Font.PLAIN,14);
            Font namenFont = new Font("Default", Font.BOLD, 18);
            Font attrMethFont = new Font("Default", Font.BOLD, 14);

            // Datenstrukturen zur Ausmaberechnung anlegen
            FontMetrics fmDef = getFontMetrics(defaultFont);
            FontMetrics fmName = getFontMetrics(namenFont);
            FontMetrics fmAttrMeth = getFontMetrics(attrMethFont);




            // Lege leeren Vector fr die einzelnen Strings an
            Vector zeilen = new Vector();

            // erstelle Strings fr die einzelnen Zeilen

            // Zeile 0: Stereotyp
            zeilen.add("<<"+kl_.getStereotyp()+">>");

            // Zeile 1: Paket und Name
            zeilen.add(kl_.getPacket()+"::"+kl_.getName());

            // Zeile 2: Sichtbarkeit und ggf. abstract
            String publicAbstract = "public";
            if (kl_.getVisibility()==1) publicAbstract = "protected";
            if (kl_.getVisibility()==2) publicAbstract = "private";
            if (kl_.getAbstrakt()) publicAbstract = publicAbstract + ", abstract";
            zeilen.add(publicAbstract);

            // Zeile 3: Zusicherungen
            zeilen.add("{" + kl_.getZusicherung() + "}");
            int zeilenNr = 4;

            // Zeile 4 bis (4 + #Attribute - 1): Attribute
            int attribAnzahl = 0;
            if (showAttribute_)
                {
                attribAnzahl = kl_.getAttributAnzahl();
                for (int i=0; i<attribAnzahl; i++)
                zeilen.add(kl_.getAttribute(i).getString());
                zeilenNr = zeilenNr + attribAnzahl;
                }

            // Zeile (4 + #Attribute) bis Ende: Methoden
            // Aufbau der Methoden-Darstellung:
            //    Zeile 0: Visibility + ggf. static + Rckgabewert + Name + "("
            //    Zeile 1 bis (Ende-1): ParamTyp + ParamName
            //    Letzte Zeile: ParamTyp + ParamName + ")"
            // int zeilenNr zhl dabei die Zeilen mit


            if (showMethoden_)
                {
                zeilenNr = 4 + attribAnzahl;
                int methodenAnzahl = kl_.getMethodenAnzahl();
                for (int i=0; i<methodenAnzahl; i++)
                    {
                    UmlKlassenMethode m = kl_.getMethoden(i);
                    String str = new String("public ");
                    if (m.getVisibility()==1) str = "protected ";
                    if (m.getVisibility()==2) str = "private ";
                    if (m.getStatisch()) str = str + "static ";
                    zeilen.add(str + m.getRckgabewert() + " " + m.getName() + "(");
                    int paramAnz = m.getParameterAnzahl();
                    for (int j=0; j<paramAnz; j++)
                        {
                        str = "        " + m.getParameter(j).getTyp() + " " + m.getParameter(j).getName();
                        if (j==paramAnz-1) zeilen.add(str + ")");
                        else zeilen.add(str + ",");
                        }
                    zeilenNr = zeilenNr + paramAnz + 1;
                    }
                }

            // Breiten ermitteln (der int-Vektor "breiten" enthlt danach die Zeilenbreiten)
            Vector breiten = new Vector();
            breite_ = 0;
            for (int i=0; i<zeilenNr; i++)
                {
                int a = fmDef.stringWidth((String)zeilen.get(i));
                if (i==1) a = fmName.stringWidth((String)zeilen.get(1));
                if (a>breite_) breite_ = a;
                breiten.add(new Integer(a));
                }
            breite_ = breite_ + 2 * randLinks_;


            // Erstes Rechteck
            g.setFont(defaultFont);
            int cursorY = offsetY_ + randOben_ + fmDef.getHeight();
            int cursorX = getCenterX(((Integer)breiten.get(0)).intValue());
            g.drawString((String)zeilen.get(0),cursorX, cursorY);

            cursorY = cursorY + zeilenAbstand_ + fmName.getHeight();
            cursorX = getCenterX(((Integer)breiten.get(1)).intValue());
            g.setFont(namenFont);
            g.drawString((String)zeilen.get(1), cursorX, cursorY);

            cursorY = cursorY + zeilenAbstand_ + fmDef.getHeight();
            cursorX = getCenterX(((Integer)breiten.get(2)).intValue());
            g.setFont(defaultFont);
            g.drawString((String)zeilen.get(2), cursorX, cursorY);

            cursorY = cursorY + zeilenAbstand_ + fmDef.getHeight();
            cursorX = getCenterX(((Integer)breiten.get(3)).intValue());
            g.drawString((String)zeilen.get(3), cursorX, cursorY);
            cursorY = cursorY + randUnten_;

            g.drawRect(offsetX_, offsetY_, breite_, cursorY - offsetY_);

            // Zweites Rechteck (Attribute)
            if (showAttribute_)
                {
                int oben = cursorY;
                cursorY = cursorY + randOben_ + fmAttrMeth.getHeight();
                cursorX = getCenterX(fmAttrMeth.stringWidth("Attribute"));
                g.setFont(attrMethFont);
                g.drawString("Attribute:", cursorX, cursorY);
                g.setFont(defaultFont);


                for(int i=0; i<attribAnzahl; i++)
                    {
                    cursorY = cursorY + zeilenAbstand_ + fmDef.getHeight();
                    g.drawString((String)zeilen.get(i+4), randLinks_ + offsetX_, cursorY);
                    }

                cursorY = cursorY + randUnten_;
                g.drawRect(offsetX_, oben, breite_, cursorY - oben);
                }

            // drittes Rechteck (Methoden)
            if (showMethoden_)
                {
                int oben = cursorY;

                cursorY = cursorY + randOben_ + fmAttrMeth.getHeight();
                cursorX = getCenterX(fmAttrMeth.stringWidth("Attribute"));
                g.setFont(attrMethFont);
                g.drawString("Methoden:", cursorX, cursorY);
                g.setFont(defaultFont);

                for (int i=4+attribAnzahl; i<zeilen.size(); i++)
                    {
                    cursorY = cursorY + zeilenAbstand_ + fmDef.getHeight();
                    g.drawString((String)zeilen.get(i), randLinks_ + offsetX_, cursorY);
                    }
                cursorY = cursorY + randUnten_;
                g.drawRect(offsetX_, oben, breite_, cursorY - oben);
                }


            }


        // Diese Methode liefert bei Angabe der Zeilenbreite mithilfe der
        // Attribute breite_ und offsetX_ die x-Koordinate zurck, bei
        // der die Schrift beginnen mu, um zentriert zu stehen

        private int getCenterX(int zeilenBreite)
            {
            return offsetX_ + (breite_ - zeilenBreite)/2;
            }


            }
