package Utopp.Verbindung;
/*

Version 1.1, 10.01.1 20:01.

Autor: Florian Wessels, florian.wessels@math.uni-muenster.de
Datum: 5.1.2001ff

Diese Klasse nimmt als Eingabe eine Uml-Verbindung
und zeigt diese dann in einem Fensterchen an.

*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import Utopp.Komponenten.*;
import java.awt.font.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import java.util.Vector;


public class UmlVerbindungZeigen extends Frame implements ActionListener {

UmlVerbindung verb;
boolean ausfuehrlich = true;

/*

Im folgenden sind immer alle Verbindungen von p0
nach p1.

*/

int[] p0 = new int[2];
int[] p1 = new int[2];

public UmlVerbindungZeigen(JFrame frame, boolean modal,UmlVerbindung verbindung) {
	this.verb = verbindung;
	this.setTitle("Verbindung "+verb.getName());
	// muss im real-life auf false gesetzt werden!
	addWindowListener(new Utopp.WindowClosingAdapter(false));
	setBackground(Color.white);
	setSize(600,400);
	// Hier wird ein Menue gemacht:
	setMenuBar(new menueVE(this));
	setVisible(true);
}

public void paint(Graphics g) {

	// SchriftGroesse und OffSet
	
	int sg = 14;
	int os = 4;

	Font font = new Font("Default",Font.PLAIN,sg);
	FontMetrics fm = getFontMetrics(font);	
		
	// Ermittle Fenstergroesse
	
	int breite = getSize().width-getInsets().right-getInsets().left;
  	int hoehe = getSize().height-getInsets().bottom-getInsets().top;
  	int xo = getInsets().left;
  	int yo = getInsets().top;
  	
  	int mitteX = xo + breite/2;
  	int mitteY = yo + hoehe/2; 
  	
  	g.setFont(font);
  	
  	p0[0] = breite/4;
  	p0[1] = mitteY;
  	p1[0] = breite-breite/4;
  	p1[1] = mitteY;
  	
  	// Durchgezogen oder gestrichelt?
   
   if (verb.getLinie() != null && verb.getLinie().getDurchgezogen()) {
     	g.drawLine(p0[0],p0[1], p1[0],p1[1]);
   	} else drawGestrichelt(g,p0[0],p0[1], p1[0],p1[1]);
   	
   // Start?
   
   // Das folgende nur, falls "ausfuehrlich" erwuenscht!
   
   if (ausfuehrlich) {
   
   	if (! (verb.getStart() == null)) {
   	
		// Vor.: Verb. geht p0 -> p1. Sonst muss vorher gewechstelt werden!
		
	   		// keine Exc. moeglich, da verb.getStart() != null.
	   	
	   		if (verb.getStart().getMulti() != null) g.drawString(verb.getStart().getMulti(),p0[0]+os,p0[1]-os);
	   		if (verb.getStart().getRolle() != null) g.drawString(verb.getStart().getRolle(),p0[0]+os,p0[1]+sg+os);
   	
   	}
   	
   	// Ende?
   	
   	// Zunaechst fuer "rolle: Schnittstelle":
   	
   	if (verb.getEnde() != null && verb.getEnde().getRolle() != null) {
	
		   	g.drawString(verb.getEnde().getRolle(),p1[0]-fm.stringWidth(verb.getEnde().getRolle()),p1[1]+sg+os);
   
   	}
   
   	// Zusicherung, nur wenn String nicht leer.

   	if (verb.getZusicherung() != null && verb.getZusicherung().length() != 0) {

   		String s = verb.getZusicherung();	// != null!
   		g.drawString("{"+s+"}",mitteX-(fm.stringWidth("{"+s+"}"))/2,p1[1]-os);

   	}

   	// Stereotyp, bei Vererbungen:

   	if (verb.getKompTyp() == "UmlVererbung") {

   		if (((UmlVererbung)verb).getStereotyp() != null && ((UmlVererbung)verb).getStereotyp().length() != 0) {

		   String s = "<<"+((UmlVererbung)verb).getStereotyp()+">>";

   		g.drawString(s,mitteX-(fm.stringWidth("<<"+s+">>"))/2,p1[1]-(2*os+sg));
   		}
   	}// if Vererbung

	} // Ende if ausfuerhlich.

	/*

	A c h t u n g:

	Diskriminator wegen mangelndem Sinn in diesem Stadium nicht implementiert.

	*/

	// Jetzt muessen noch die Pfeile/Rauten dran!

	//System.out.println(verb.getEnde().getKompTyp());	// Debug-technisch...

	Endung ende = verb.getEnde();

		int px = p1[0];
		int py = p1[1];
	
	if (verb.getEnde() != null && verb.getEnde().getKompTyp() == "EndungRaute") 	{
	
		// Die Koordinaten fuer die Raute:
	
		int[] arx = {px,px+8,px+16,px+8};
		int[] ary = {py,py-4,py,py+4};
	

		
		if (((EndungRaute)ende).getGefllt()==false)
		{
		
		// Wir malen eine nicht-gefuellte Raute:
		
			g.drawPolygon(arx,ary,4);
		
		} else {
		
			g.fillPolygon(arx,ary,4);					
		
		}
	}// if Raute
	
	
	if (verb.getEnde() != null && verb.getEnde().getKompTyp() == "EndungPfeil") 
	{
	
	int[] arx = {px,px+16,px};
	int[] ary = {py-4,py,py+4};
	
		if (!((EndungPfeil)ende).getGeschlossen())
		{
			g.drawPolyline(arx,ary,3);
			g.drawLine(arx[0],p0[1],arx[1],p0[1]);
		}
		
		else {
			if (!((EndungPfeil)ende).getGefllt()) g.drawPolygon(arx,ary,3);
			else g.fillPolygon(arx,ary,3);
		}
	}// if Pfeil.
}// Ende paint-Methode.

	/**
	
	Diese Methode malt den hoechsten aesthetischen Anspruechen
	genuegende gestrichelte Linien.
	
	*/

	void drawGestrichelt (Graphics g, int p00, int p01, int p10, int p11) {

		// Wir malen momentan nur horizontale Linien!
		
		if (p00 > p10) {	int temp = p10; p10 = p00; p00 = temp;	}
	
		while (p00<p10) {
		
			g.drawLine(p00,p01, p00+2,p11);			
			p00 += 6;
		
		}
		
	
	}

/*

Fuer das Menu noch die Aktionen...

*/
	
public void actionPerformed(ActionEvent event) {
      String cmd = event.getActionCommand();
      if (cmd.equals("Nicht nur ein Pfeil")) {
         ausfuehrlich=true;
         this.repaint();
      } else if (cmd.equals("Nur ein Pfeil")) {
         ausfuehrlich=false;
         this.repaint();
      }
}	
	

}